'Const TurnSpeed:Float = 4.00 ' cam turn speed
'Const CameraSpeed:Float = 0.25 ' cam move speed
Global tx:Float, ty:Float, ti:Int ' mouse help variables
Global cp:Float, cy:Float, cr:Float

Function Movement(target:TEntity,movespeed:Float=1.0,sensitivity:Float=1.0,turnspeed:Float=4.0,rollspeed:Float=2)
	
	Local width:Int = GraphicsWidth()
	Local height:Int = GraphicsHeight()

	Local roll:Float, cz:Float, tx:Float, ty:Float, pos:Float
	
	cz = (KeyDown(KEY_UP) - KeyDown(KEY_DOWN)) + (KeyDown(KEY_W) - KeyDown(KEY_S))
	roll = (KeyDown(KEY_LEFT) - KeyDown(KEY_RIGHT)) + (KeyDown(KEY_A) - KeyDown(KEY_D))
	
	tx = Normalize(MouseX(), 0, width, 1, -1)
	ty = Normalize(MouseY(), 0, HEIGHT, -1, 1)
	
	If ty < 0 Then ty = (Abs(ty) ^ sensitivity) * -1 Else ty = ty ^ sensitivity
	If tx < 0 Then tx = (Abs(tx) ^ sensitivity) * -1 Else tx = tx ^ sensitivity
	
	Turn target, ty * turnspeed, tx * turnspeed, roll*rollspeed

	MoveEntity target, 0, 0, cz * movespeed
	
End Function

Function Turn(Ent:TEntity,X:Float,Y:Float,Z:Float,Glob:Int=False)

	Local Pitch:Float = 0.0
	Local Yaw:Float = 0.0
	Local Roll:Float = 0.0
	
	Local Quat:TQuaternion = EulerToQuat2(0.0, 0.0, 0.0)
	Local Turn_Quat:TQuaternion = EulerToQuat2(0.0, 0.0, 0.0)
	
	If Glob=False
	
		Quat = EulerToQuat2(EntityPitch(Ent, True), EntityYaw(Ent, True), EntityRoll(Ent, True))
		Turn_Quat = EulerToQuat2(X, Y, Z)
		Quat = MultiplyQuats2(Quat, Turn_Quat)
		Quat = NormalizeQuat2(Quat)
		QuatToEuler2( Quat.x, Quat.y, Quat.z, Quat.w, Pitch, Yaw, Roll )
		RotateEntity Ent, Pitch, Yaw, Roll
	Else
	
		RotateEntity Ent, EntityPitch( Ent )+X, EntityYaw( Ent )+Y, EntityRoll( Ent )+Z
		
	EndIf
	
End Function

Function EulerToQuat2:TQuaternion(pitch:Float, yaw:Float, roll:Float)

	Local cr:Float=Cos(-roll/2.0)
	Local cp:Float=Cos(pitch/2.0)
	Local cy:Float=Cos(yaw/2.0)
	Local sr:Float=Sin(-roll/2.0)
	Local sp:Float=Sin(pitch/2.0)
	Local sy:Float=Sin(yaw/2.0)
	Local cpcy:Float=cp*cy
	Local spsy:Float=sp*sy
	Local spcy:Float = sp * cy
	Local cpsy:Float=cp*sy
	
	Local q:TQuaternion=New TQuaternion
	
	q.w:Float=cr*cpcy+sr*spsy
	q.x:Float=sr*cpcy-cr*spsy
	q.y:Float=cr*spcy+sr*cpsy
	q.z:Float=cr*cpsy-sr*spcy
	
	Return q
	
End Function

Function QuatToEuler2(x:Float,y:Float,z:Float,w:Float,pitch:Float Var,yaw:Float Var,roll:Float Var)

	Local sint:Float=(2.0*w*y)-(2.0*x*z)
	Local cost_temp:Float=1.0-(sint*sint)
	Local cost:Float

	If Abs(cost_temp)>QuatToEulerAccuracy

		cost=Sqr(cost_temp)

		Else

		cost=0.0

	EndIf

	Local sinv:Float,cosv:Float,sinf:Float,cosf:Float
	
	If Abs(cost)>QuatToEulerAccuracy
	
		sinv=((2.0*y*z)+(2.0*w*x))/cost
		cosv=(1.0-(2.0*x*x)-(2.0*y*y))/cost
		sinf=((2.0*x*y)+(2.0*w*z))/cost
		cosf=(1.0-(2.0*y*y)-(2.0*z*z))/cost
		
	Else
		
		sinv=(2.0*w*x)-(2.0*y*z)
		cosv=1.0-(2.0*x*x)-(2.0*z*z)
		sinf=0.0
		cosf=1.0
		
	EndIf
	
	pitch=ATan2(sint,cost)
	yaw=ATan2(sinf,cosf)
	roll=-ATan2(sinv,cosv)
	
End Function

Function MultiplyQuats2:TQuaternion(q1:TQuaternion, q2:TQuaternion)

	Local q:TQuaternion=New TQuaternion
	
	q.w = q1.w*q2.w - q1.x*q2.x - q1.y*q2.y - q1.z*q2.z
	q.x = q1.w*q2.x + q1.x*q2.w + q1.y*q2.z - q1.z*q2.y
	q.y = q1.w*q2.y + q1.y*q2.w + q1.z*q2.x - q1.x*q2.z
	q.z = q1.w*q2.z + q1.z*q2.w + q1.x*q2.y - q1.y*q2.x

	Return q

End Function

Function NormalizeQuat2:TQuaternion(q:TQuaternion)

	Local uv:Float=Sqr(q.w*q.w+q.x*q.x+q.y*q.y+q.z*q.z)

	q.w=q.w/uv
	q.x=q.x/uv
	q.y=q.y/uv
	q.z=q.z/uv

	Return q

End Function

' ----------------------------------------------------------------------------
' Reset Mouse to Screen Center
' ----------------------------------------------------------------------------
Function ResetMouse()

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	MouseXSpeed()
	MouseYSpeed()
	MouseZSpeed()
	
End Function

' ----------------------------------------------------------------------------
' Move Mouse pointer to Screen Center
' ----------------------------------------------------------------------------
Function CenterMouse()

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

End Function
