SuperStrict

Framework sidesign.minib3d
Import brl.random
Import brl.timer

Graphics3D 1024, 600, 0, 2

'THardwareInfo.GetInfo
'THardwareInfo.DisplayInfo 0

'Graphics3D THardwareInfo.ScreenWidth, THardwareInfo.ScreenHeight, 0, 2, 60

Const QuatToEulerAccuracy:Double = 1.0 / 2 ^ 512

Include "inc/TCam.bmx"
Include "inc/TMatrix.bmx"
Include "inc/TQuad.bmx"
Include "inc/TQuaternion.bmx"
Include "inc/TQuat.bmx"
Include "inc/TMouse.bmx"
Include "inc/TMilkyway.bmx"

Global CAMERA:TCam
Global MILKYWAY:TMilkyway

CAMERA:TCam = New TCam
CAMERA.Add()
CAMERA.X = -15
CAMERA.Y = 0
CAMERA.Z = 0
CAMERA.Roll = 0
CAMERA.RangeMin = 0.1
CAMERA.RangeMax = 10000
CAMERA.CLScolor = [0, 4, 8]
CAMERA.Update()

Local StarTexture:TTexture = LoadTexture("textures/milkyway/star.png", 2)
Local StarsTexture:TTexture = LoadTexture("textures/milkyway/stars.png", 2)
Local PanoramaTexture:TTexture = LoadTexture("textures/milkyway/milkyway.jpg", 1 + 16 + 32)
Local NebulaTexture:TTexture = LoadTexture("textures/milkyway/nebula.png", 2 + 16 + 32)
TextureBlend PanoramaTexture, 2
TextureBlend NebulaTexture, 2
ScaleTexture StarsTexture, 2, 2

MILKYWAY:TMilkyway = New TMilkyway
MILKYWAY.StarTexture = StarTexture
MILKYWAY.StarsTexture = StarsTexture
MILKYWAY.PanoramaTexture = PanoramaTexture
MILKYWAY.NebulaTexture = NebulaTexture
MILKYWAY.Stars = 2500
MILKYWAY.MaxAngle = 60
MILKYWAY.NebulaAmount = 50
MILKYWAY.StarScale = 2.5
MILKYWAY.Init

'HideEntity MILKYWAY.StarSphere
'HideEntity MILKYWAY.Nebula
'HideEntity MILKYWAY.Panorama
'HideEntity MILKYWAY.Starbox

Local lighttype:Int = 2
Local light:TLight=CreateLight(lighttype)
RotateEntity light, 0, 0, 0
PositionEntity light, 0, 0, 0
LightRange light, 1000

AmbientLight 0, 0, 0

Local sun:TSprite = CreateSprite(light)
Local suntex:TTexture = LoadTexture("textures/Sun.png", 2)
ScaleSprite sun, 5, 5
EntityTexture sun, suntex

Local pivot:TPivot = CreatePivot()
Local planet:TMesh = CreateSphere(64, pivot)
PositionEntity planet, 0, 0, 10
Local colormap:TTexture = LoadTexture("textures/Moon.jpg", 1 + 16 + 32)

'Local shader:TShader = LoadShader("", "shaders/test.vert.glsl", "shaders/test.frag.glsl")
'ShaderTexture(shader, colormap, "tex0", 0)
'SetInteger(shader, "lighttype", lighttype)
'ShadeEntity(planet, shader)

EntityFX planet, 2
EntityTexture planet, colormap
TextureBlend colormap, 5

PointEntity CAMERA.cam, sun

CenterMouse()

Local intensity:Float = 1.5
Local test:Int = 1

While Not KeyDown(KEY_ESCAPE)

	TurnEntity planet, 0, 0.05, 0
	'TurnEntity pivot, 0, 0.25, 0
	'intensity:+((KeyDown(KEY_E) - KeyDown(KEY_Q)) / 100.0)
	'SetFloat(shader, "intensity", intensity)
	
	Movement(CAMERA.cam, 0.05 * (1 + (KeyDown(KEY_LSHIFT) * 10)), 1.5, 8)
	
	MILKYWAY.KeepPosition(CAMERA.cam)
	
	RenderWorld
	
	If KeyHit(KEY_SPACE) Then test = 1 - test
	
	If test Then
	
		BeginMax2D()
	
			DrawText MilliSecs(), 0, 0
	
		EndMax2D()
		
	EndIf
	
	Flip

Wend
End

Function Normalize:Float(value:Float = 128.0, value_min:Float = 0.0, value_max:Float = 255.0, norm_min:Float = 0.0, norm_max:Float = 1.0)
	
	Return ((value-value_min)/(value_max-value_min))*(norm_max-norm_min)+norm_min
	
End Function